import arcpy
import geopy
import csv
from geopy.geocoders import Nominatim
geolocator = Nominatim()

failed_text =""
numbers_failed = 0
outShp=arcpy.GetParameterAsText(0)
inFC=arcpy.GetParameterAsText(1)
outFC=arcpy.GetParameterAsText(4)
adresse=arcpy.GetParameterAsText(2)
place=arcpy.GetParameterAsText(3)
cursor = arcpy.InsertCursor(outShp)
with open(outFC, 'w') as file:
	with open(inFC, 'rb') as csvfile:
		content = csv.DictReader(csvfile, delimiter='\t')
		for row in content:
			feature = cursor.newRow()
			vertex = arcpy.CreateObject("Point")
			coord = geolocator.geocode(row[adresse].decode('latin1') + row[place].decode('latin1') ,timeout=25)
			
                        if coord is None:
				failed_text += row[adresse] + row[place] + "\n"
				numbers_failed += 1
                                
			if coord is not None:
                                vertex.X = coord.longitude
				vertex.Y = coord.latitude
                                feature.shape=vertex
                                feature.Nom=row[adresse]
				cursor.insertRow(feature)
                               
	file.write(failed_text)
	file.close()
del cursor
print "failed geocodes: " + str(numbers_failed) + "!!! check the file " + outFC

dataframe = arcpy.mapping.ListDataFrames(arcpy.mapping.MapDocument('current'))[0]  
geocodelayer = arcpy.mapping.Layer(outShp)
arcpy.mapping.AddLayer(dataframe,geocodelayer,"BOTTOM") 
layer_extent = geocodelayer.getExtent()
dataframe.extent = layer_extent